﻿//	Spludlow Software
//	Copyright © Samuel P. Ludlow 2020 All Rights Reserved
//	Distributed under the terms of the GNU General Public License version 3
//	Distributed WITHOUT ANY WARRANTY; without implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE
//	https://www.spludlow.co.uk/LICENCE.TXT
//	The Spludlow logo is a registered trademark of Samuel P. Ludlow and may not be used without permission
//	v1.14

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Spludlow.Mame
{
	public class MameDatabaseHashes
	{
		private HashSet<string> _MachineRom = null;
		private HashSet<string> _MachineDisk = null;
		private HashSet<string> _SoftwareRom = null;
		private HashSet<string> _SoftwareDisk = null;

		public MameDatabaseHashes()
		{
		}

		public HashSet<string> MachineRom
		{
			get
			{
				if (_MachineRom == null)
					_MachineRom = MameDatabase.MachineRomHashes();
				return _MachineRom;
			}
		}
		public HashSet<string> MachineDisk
		{
			get
			{
				if (_MachineDisk == null)
					_MachineDisk = MameDatabase.MachineDiskHashes();
				return _MachineDisk;
			}
		}
		public HashSet<string> SoftwareRom
		{
			get
			{
				if (_SoftwareRom == null)
					_SoftwareRom = MameDatabase.SoftwareRomHashes();
				return _SoftwareRom;
			}
		}
		public HashSet<string> SoftwareDisk
		{
			get
			{
				if (_SoftwareDisk == null)
					_SoftwareDisk = MameDatabase.SoftwareDiskHashes();
				return _SoftwareDisk;
			}
		}
	}
}
