﻿//	Spludlow Software
//	Copyright © Samuel P. Ludlow 2020 All Rights Reserved
//	Distributed under the terms of the GNU General Public License version 3
//	Distributed WITHOUT ANY WARRANTY; without implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE
//	https://www.spludlow.co.uk/LICENCE.TXT
//	The Spludlow logo is a registered trademark of Samuel P. Ludlow and may not be used without permission
//	v1.14

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Data;

namespace Spludlow.Mame
{
	public class MameHashStoreUI
	{
		public static void Console()
		{
			DataTable menuTable = Spludlow.Data.TextTable.ReadText(new string[]
			{
				"Group	Option	Text								Target	Assembly		Type							Method					Parameter",
				"Int32*	Int32*	String								Int32	String			String							String					String",

				"0		1		Configuration						1",
				"0		2		Database							2",
				"0		3		Import								3",
				"0		4		Link								4",
				"0		5		Export								5",
				"0		6		Verify								6",
				"0		7		Clean								7",
				"0		8		Reports								8",

				"1		1		Show Configuration					-1		Spludlow.Mame	Spludlow.Mame.MameConfiguration	Show",
				"1		2		Test Configuration					-1		Spludlow.Mame	Spludlow.Mame.MameConfiguration	Test",
				"1		3		Show Mame Rom Path					-1		Spludlow.Mame	Spludlow.Mame.MameConfiguration	MameRomPath",

				"2		1		Import Database						-1		Spludlow.Mame	Spludlow.Mame.MameDataImport	Import",
				"2		2		Report All Database					-1		Spludlow.Mame	Spludlow.Mame.MameDatabase		DumpAllToReport",

				"3		1		Summary Report						-1		Spludlow.Mame	Spludlow.Mame.MameReports		Summary",
				"3		2		Import files						-1		Spludlow.Mame	Spludlow.Mame.MameImport		Import",
				"3		3		Import files (No Disk Verify)		-1		Spludlow.Mame	Spludlow.Mame.MameImport		ImportNoDiskVerify",
				"3		4		Import files						-1		Spludlow.Mame	Spludlow.Mame.MameImport		Import					@Import Directory",
				"3		5		Import files (No Disk Verify)		-1		Spludlow.Mame	Spludlow.Mame.MameImport		ImportNoDiskVerify		@Import Directory",

				"4		1		Link All							-1		Spludlow.Mame	Spludlow.Mame.MameLink			LinkAll",
				"4		2		Link Machine Rom					-1		Spludlow.Mame	Spludlow.Mame.MameLink			LinkMachineRom",
				"4		3		Link Machine Disk					-1		Spludlow.Mame	Spludlow.Mame.MameLink			LinkMachineDisk",
				"4		4		Link Software Rom					-1		Spludlow.Mame	Spludlow.Mame.MameLink			LinkSoftwareRom",
				"4		5		Link Software Disk					-1		Spludlow.Mame	Spludlow.Mame.MameLink			LinkSoftwareDisk",

				"5		1		Export Machine Rom All				-1		Spludlow.Mame	Spludlow.Mame.MameExport		ExportMachineRom",
				"5		2		Export Machine Rom					-1		Spludlow.Mame	Spludlow.Mame.MameExport		ExportMachineRom		@Machine Name",
				"5		3		Export Machine Disk All				-1		Spludlow.Mame	Spludlow.Mame.MameExport		ExportMachineDisk",
				"5		4		Export Machine Disk All				-1		Spludlow.Mame	Spludlow.Mame.MameExport		ExportMachineDiskTarget	@Export Directory",
				"5		5		Export Machine Disk					-1		Spludlow.Mame	Spludlow.Mame.MameExport		ExportMachineDisk		@Machine Name",
				"5		6		Export Software Rom All				-1		Spludlow.Mame	Spludlow.Mame.MameExport		ExportSoftwareRom",
				"5		7		Export Software Rom					-1		Spludlow.Mame	Spludlow.Mame.MameExport		ExportSoftwareRom		@Software List Name",
				"5		8		Export Software Disk All			-1		Spludlow.Mame	Spludlow.Mame.MameExport		ExportSoftwareDisk",
				"5		9		Export Software Disk				-1		Spludlow.Mame	Spludlow.Mame.MameExport		ExportSoftwareDisk		@Software List Name",

				"6		1		Verify Machine Rom					-1		Spludlow.Mame	Spludlow.Mame.MameVerify		VerifyMachineRom",
				"6		2		Verify Machine Disk					-1		Spludlow.Mame	Spludlow.Mame.MameVerify		VerifyMachineDisk",
				"6		3		Check (Fast) Machine Disk			-1		Spludlow.Mame	Spludlow.Mame.MameVerify		CheckMachineDisk",
				"6		4		Verify Software Rom					-1		Spludlow.Mame	Spludlow.Mame.MameVerify		VerifySoftwareRom",
				"6		5		Verify Software Disk				-1		Spludlow.Mame	Spludlow.Mame.MameVerify		VerifySoftwareDisk",
				"6		6		Check (Fast) Software Disk			-1		Spludlow.Mame	Spludlow.Mame.MameVerify		CheckSoftwareDisk",
				"6		7		SHA1 Hash							-1		Spludlow		Spludlow.Hashing				SHA1HexFile				@Filename",
				"6		8		CHDMAN Verify						-1		Spludlow.Mame	Spludlow.Mame.MameChdMan		VerifyRaw				@Filename",

				"7		1		Summary Report						-1		Spludlow.Mame	Spludlow.Mame.MameReports		Summary",
				"7		2		Clean All							-1		Spludlow.Mame	Spludlow.Mame.MameClean			CleanAll",
				"7		3		Clean Machine Rom					-1		Spludlow.Mame	Spludlow.Mame.MameClean			CleanMachineRom",
				"7		4		Clean Machine Disk					-1		Spludlow.Mame	Spludlow.Mame.MameClean			CleanMachineDisk",
				"7		5		Clean Software Rom					-1		Spludlow.Mame	Spludlow.Mame.MameClean			CleanSoftwareRom",
				"7		6		Clean Software Disk					-1		Spludlow.Mame	Spludlow.Mame.MameClean			CleanSoftwareDisk",

				"8		1		Summary Report						-1		Spludlow.Mame	Spludlow.Mame.MameReports		Summary",
				"8		2		Missing Machine Rom					-1		Spludlow.Mame	Spludlow.Mame.MameReports		MissingMachineRom",
				"8		3		Missing Machine Disk				-1		Spludlow.Mame	Spludlow.Mame.MameReports		MissingMachineDisk",
				"8		4		Missing Software Rom				-1		Spludlow.Mame	Spludlow.Mame.MameReports		MissingSoftwareRom",
				"8		5		Missing Software Disk				-1		Spludlow.Mame	Spludlow.Mame.MameReports		MissingSoftwareDisk",
				"8		6		Software Disk by List				-1		Spludlow.Mame	Spludlow.Mame.MameReports		SoftwareDiskByList",
				"8		7		CHD Info							-1		Spludlow.Mame	Spludlow.Mame.MameReports		ChdInfo					@Directory Name",
				"8		8		CHD Info Machine Disk				-1		Spludlow.Mame	Spludlow.Mame.MameReports		ChdInfoMachine",
				"8		9		CHD Info Software Disk				-1		Spludlow.Mame	Spludlow.Mame.MameReports		ChdInfoSoftware",
				"8		10		Silly Names Report					-1		Spludlow.Mame	Spludlow.Mame.MameReports		SillyNames",
			});

			Spludlow.ConsoleMenu.Run(menuTable);
		}
	}
}
